unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Tiles, Menus, ExtDlgs;

type
  TFormMain = class(TForm)
    DlgSaveTlr: TSaveDialog;
    Button1: TButton;
    Button2: TButton;
    Panel1: TPanel;
    Panel2: TPanel;
    ImgBitmap: TImage;
    Panel3: TPanel;
    ImgFreemap: TImage;
    Button3: TButton;
    Button4: TButton;
    LbCount: TLabel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    OpenTileset1: TMenuItem;
    SaveTileset1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    NewTileset1: TMenuItem;
    DlgOpenTlr: TOpenDialog;
    Button5: TButton;
    DlgOpen: TOpenPictureDialog;
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure UpdateEd;
    procedure NewTileset1Click(Sender: TObject);
    procedure OpenTileset1Click(Sender: TObject);
    procedure SaveTileset1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;
  Count, Index: Integer;
  Tl: TTiles;

implementation

{$R *.dfm}

procedure TFormMain.Button3Click(Sender: TObject);
begin
  if DlgOpen.Execute then
    if FileExists(DlgOpen.FileName) then
    begin
      ImgBitmap.Picture.LoadFromFile(DlgOpen.FileName);
      if (ImgBitmap.Picture.Bitmap.Width <> TileWidth) or (ImgBitmap.Picture.Bitmap.Height <> TileHeight) then
      begin
        ImgBitmap.Picture.Bitmap := nil;
        ShowMessage('Slika mora biti dimenzija ' + IntToStr(TileWidth) + 'x' + IntToStr(TileHeight));
      end;
    end;
end;

procedure TFormMain.Button4Click(Sender: TObject);
begin
  if DlgOpen.Execute then
    if FileExists(DlgOpen.FileName) then
    begin
      ImgFreemap.Picture.LoadFromFile(DlgOpen.FileName);
      if (ImgFreemap.Picture.Bitmap.Width <> TileWidth) or (ImgFreemap.Picture.Bitmap.Height <> TileHeight) then
      begin
        ImgFreemap.Picture.Bitmap := nil;
        ShowMessage('Slika mora biti dimenzija ' + IntToStr(TileWidth) + 'x' + IntToStr(TileHeight));
      end;
    end;
end;

procedure TFormMain.Button1Click(Sender: TObject);
begin
  if Index <= 0 then Exit;
  Dec(Index);
  ImgBitmap.Picture.Bitmap.Assign(Tl.GetBitmap(Index));
  Tl.GetFreemapAsBitmap(Index, ImgFreemap.Picture.Bitmap);
  UpdateEd;
end;

procedure TFormMain.Button2Click(Sender: TObject);
begin
  if Index = Count - 1 then Exit;
  Inc(Index);
  ImgBitmap.Picture.Bitmap.Assign(Tl.GetBitmap(Index));
  Tl.GetFreemapAsBitmap(Index, ImgFreemap.Picture.Bitmap);
  UpdateEd;
end;

procedure TFormMain.FormCreate(Sender: TObject);
begin
  Index := -1;
  Count := 0;
  Tl := TTiles.Create;
end;

procedure TFormMain.UpdateEd;
begin
  LbCount.Caption := IntToStr(Index + 1) + '/' + IntToStr(Count);
end;

procedure TFormMain.NewTileset1Click(Sender: TObject);
begin
  if Tl.TileCount > 0 then
    if MessageDlg('Current tileset contains tiles, do you really want a new tileset?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
      Tl.Destroy;
      Tl := TTiles.Create;
      Index := -1;
      Count := 0;
      ImgBitmap.Picture.Bitmap := nil;
      ImgFreemap.Picture.Bitmap := nil;
      UpdateEd;
    end;
end;

procedure TFormMain.OpenTileset1Click(Sender: TObject);
begin
  if Tl.TileCount > 0 then
    if MessageDlg('Current tileset contains tiles, do you really want to load a new tileset?', mtConfirmation, [mbYes, mbNo], 0) = mrNo then
      Exit;
  if DlgOpenTlr.Execute then
  begin
    Tl.Destroy;
    Tl := TTiles.Create;
    Tl.LoadTiles(DlgOpenTlr.FileName);
    Count := Tl.TileCount;
    Index := -1;
    if Tl.TileCount > 0 then
      Button2Click(Self);
    UpdateEd;
  end;
end;

procedure TFormMain.SaveTileset1Click(Sender: TObject);
begin
  if DlgSaveTlr.Execute then
    Tl.SaveTiles(DlgSaveTlr.FileName);
end;

procedure TFormMain.Button5Click(Sender: TObject);
begin
  if ImgBitmap.Picture.Bitmap <> nil then
  begin
    Tl.AddTile(ImgBitmap.Picture.Bitmap, ImgFreemap.Picture.Bitmap);
    Inc(Index);
    Inc(Count);
    ImgBitmap.Picture.Bitmap := nil;
    ImgFreemap.Picture.Bitmap := nil;
    UpdateEd;
  end
end;

end.
